#include <windows.h>
#include <stdlib.h>
#include <stdio.h>
#include <math.h>

//   
#define MAX_N 128

//  
#define Diap_1 1.0
#define Diap_2 10.0

//,        
#define Diap   5.0

//  
#define Diap__1 1.0
#define Diap__2 10.0

double signal_1[MAX_N];
double signal_2[MAX_N];
double signal_2_0[MAX_N];

double ReturnM(double *p);
double ReturnD(double *p,double m);
double ReturnK(double *p,double *p1,double m,double m1,double d,double d1);
int ReturnP(double *p);



int main(int argc, char* argv[])
{
	//  
	int i,j;
	int Matrix[MAX_N-1];
	int b;
	double res1,t;
	double Koef=0;//.  
	int rang[MAX_N];

	for(i=0;i<MAX_N;i++)
		signal_1[i]=Diap_1+((double)(Diap_2-Diap_1)*rand()/RAND_MAX);

	FILE *f,*f1,*f2;
	char buf[256];

	f=fopen("data\\signal_1.dat","w");
	if (f==NULL) return 0;


	for(i=0;i<MAX_N;i++)
	{
		sprintf(buf,"%f \n",signal_1[i]);
		fputs(buf,f);
	}
	fclose(f);

	int wer;
	int p;
	double wer1;
	wer1=(double)(MAX_N-2)*2/3;
	wer1-=(double)1.96*sqrt((double)(16*MAX_N-29)/90);
	wer=wer1;

	// 2- 
	f1=fopen("data\\kpk.dat","w");
	if (f1==NULL) return 0;
	f2=fopen("data\\sl.dat","w");
	if (f1==NULL) return 0;

	int ZRXY=127; int ll=0;
	double dx,dx1,ppp;
	double z[4];
	

	for(ZRXY=0;ZRXY<128;ZRXY++){
	for(i=0;i<MAX_N-1;i++)
			Matrix[i]=1;
			ll++;
	//   - 
	i=0;
	if (ZRXY>0)
	do
	{
		b=floor((MAX_N-1)*(double)rand()/RAND_MAX);
		if (Matrix[b]==1)
		{
			Matrix[b]=0;
			i++;
			if (i==ZRXY) break;
		}
	}while(true);
	//    2- 
	signal_2[0]=Diap__1+((double)(Diap__2-Diap__1)*rand()/RAND_MAX);
	i=0;
	do{
		dx=signal_1[i+1]-signal_1[i];
		if (dx<0) dx=-dx;
		dx1=-dx;
		z[0]=Diap__2-(Diap__2-signal_2[i]-dx)*Koef;
		z[1]=signal_2[i]+dx*Koef;
		z[2]=signal_2[i]-dx*Koef;
		z[3]=Diap__1+(signal_2[i]-dx-Diap__1)*Koef;
		if ((Matrix[i]==1 && (signal_1[i+1]-signal_1[i])>0) || 
			(Matrix[i]==0 && (signal_1[i+1]-signal_1[i])<0)) 
			signal_2[i+1]=signal_2[i]+dx*Koef+((double)(z[0]-
z[1])*rand()/RAND_MAX);
		else 
			signal_2[i+1]=signal_2[i]-dx*Koef-((double)(z[2]-
z[3])*rand()/RAND_MAX);
		i++;
		if (i==MAX_N-1) break;
	}while(true);
	//   
	sprintf(buf,"data\\1\\sign_%d ",ll);
	f=fopen(buf,"w");
	if (f==NULL) return 0;
	for(i=0;i<MAX_N;i++)
	{
		sprintf(buf,"%f\n",signal_2[i]);
		fputs(buf,f);
	}
	fclose(f);
	// 
	sprintf(buf,"%f\t",(double)(MAX_N-1-ZRXY)/(MAX_N-1));
	for(i=0;i<lstrlen(buf);i++) if (buf[i]=='.') buf[i]=','; 
	fputs(buf,f1);
	double kp,m,m1,d,d1;
	m=ReturnM(signal_1);
	m1=ReturnM(signal_2);
	//  2
	for(i=0;i<MAX_N;i++)
	{
		ppp=signal_2[i]-m1;
		ppp*=Diap;
		signal_2[i]=m1+ppp;
	}
	d=ReturnD(signal_1,m);
	d1=ReturnD(signal_2,m1);
	kp=ReturnK(signal_1,signal_2,m,m1,d,d1);
	sprintf(buf,"%f\t%f\t%f\n",(double)m1,(double)d1,(double)kp);
	for(i=0;i<lstrlen(buf);i++) if (buf[i]=='.') buf[i]=','; 
	fputs(buf,f1);
	for(i=0;i<MAX_N;i++) {
		signal_2_0[i]=signal_2[i];
		rang[i]=i;
	}
	for(i=0;i<MAX_N;i++)
		for(j=0;j<MAX_N-i;j++)
		{
			if (signal_2_0[j]>signal_2_0[j+1])
			{
				res1=signal_2_0[j+1];
				signal_2_0[j+1]=signal_2_0[j];
				signal_2_0[j]=res1;
				b=rang[j+1];
				rang[j+1]=rang[j];
				rang[j]=b;
			}
		}

	res1=0;
	for(i=0;i<MAX_N;i++)
		res1+=pow(rang[i]-i,2);

	res1=1-6*res1/(pow(MAX_N,3)-MAX_N);
	t=1.96*sqrt((1-res1)*(1-res1)/(MAX_N-2));
	sprintf(buf,"%f\t",res1);
	for(i=0;i<lstrlen(buf);i++) if (buf[i]=='.') buf[i]=','; 
	fputs(buf,f2);
	sprintf(buf,"%f\n",t);
	for(i=0;i<lstrlen(buf);i++) if (buf[i]=='.') buf[i]=','; 
	fputs(buf,f2);

	}

	fclose(f1);
	fclose(f2);
	
	return 0;
}

double ReturnM(double *p)
{
	double q;

	int i;

	q=0;

	for(i=0;i<MAX_N;i++)
		q+=p[i];

	q/=MAX_N;

	return q;
}

double ReturnD(double *p,double m)
{
	double q;

	int i;

	q=0;

	for(i=0;i<MAX_N;i++)
		q+=pow(p[i]-m,2);

	q/=MAX_N;

	return q;
}

double ReturnK(double *p,double *p1,double m,double m1,double d,double d1)
{
	double q;

	int i;

	q=0;

	for(i=0;i<MAX_N;i++)
		q+=(double)(p[i]-m)*(p1[i]-m1);

	q=(double)q/(MAX_N*sqrt(d)*sqrt(d1));

	return q;
}

int ReturnP(double *p)
{
	int q;

	int i;

	q=0;

	for(i=1;i<MAX_N-1;i++)
		if ((p[i]>p[i-1] && p[i]>p[i+1]) ||
			(p[i]<p[i-1] && p[i]<p[i+1])) q++;

	return q;
}
